/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.facade.impl;

import java.lang.reflect.Proxy;

import org.ow2.bonita.facade.APIInterceptor;
import org.ow2.bonita.facade.QueryAPIAccessor;
import org.ow2.bonita.facade.internal.InternalQueryAPIAccessor;
import org.ow2.bonita.facade.internal.InternalQueryDefinitionAPI;
import org.ow2.bonita.facade.internal.InternalQueryRuntimeAPI;

public class StandardInternalQueryAPIAccessorImpl implements InternalQueryAPIAccessor {

  public StandardInternalQueryAPIAccessorImpl() {
  }

  public InternalQueryRuntimeAPI getQueryRuntimeAPI() {
    final Class<InternalQueryRuntimeAPI> clazz = InternalQueryRuntimeAPI.class;
    final APIInterceptor aPIInterceptor = new APIInterceptor(new QueryRuntimeAPIImpl());
    return (InternalQueryRuntimeAPI) Proxy.newProxyInstance(QueryAPIAccessor.class.getClassLoader(),
        new Class[] {clazz}, aPIInterceptor);
  }

  public InternalQueryDefinitionAPI getQueryDefinitionAPI() {
    final Class<InternalQueryDefinitionAPI> clazz = InternalQueryDefinitionAPI.class;
    final APIInterceptor aPIInterceptor = new APIInterceptor(new QueryDefinitionAPIImpl());
    return (InternalQueryDefinitionAPI) Proxy.newProxyInstance(QueryAPIAccessor.class.getClassLoader(),
        new Class[] {clazz}, aPIInterceptor);
  }

}


